(function($) {
    const searchParams = new URLSearchParams(window.location.search);
    let refreshInterval = null;
    let order_uuid = null;

    const get_order_json = async () => {
        const $spinner = $("#dwd-wc-spinner-req");
        $spinner.css("visibility", "visible");
        const response = await wp.ajax.post('dwd_wc_get_order_json', {'order_id': searchParams.get('order_id')});
        const obj = JSON.parse(response.json);
        const str = JSON.stringify(obj, null, 2); // spacing level = 2
        $("#dwd-wc-order-req").val(str);
        $spinner.fadeOut();
    }

    const inject_order = async () => {
        const $spinner = $("#dwd-wc-spinner-res");
        $spinner.css('visibility', 'visible');
        const response = await wp.ajax.post("dwd_wc_inject_order", {"order_id": searchParams.get('order_id')});
        const obj = JSON.parse(response.json);
        order_uuid = obj.uuid;
        const str = JSON.stringify(obj, null, 2); // spacing level = 2
        $("#dwd-wc-order-res").val(str);
        $spinner.fadeOut();

        $("#dwd-wc-spinner-obj").css('visibility', 'visible');

        refresh_order();
        refreshInterval = setInterval(refresh_order, 5000);
    }

    const refresh_order = async () => {
        const response = await wp.ajax.post('dwd_wc_get_order_state', {"uuid": order_uuid});
        console.log(response);
        if (response.json) {
            clearInterval(refreshInterval);
            $("#dwd-wc-spinner-obj").fadeOut();
            const obj = JSON.parse(response.json);
            const str = JSON.stringify(obj, null, 2); // spacing level = 2
            $("#dwd-wc-order-obj").val(str);
        }
    }

    const clear_textareas = () => {
        $("#dwd-wc-order-req").val("");
        $("#dwd-wc-order-res").val("");
        $("#dwd-wc-order-obj").val("");
    }

    $(document).ready(async () => {
        clear_textareas();
        get_order_json();
    });

    $(document).ready(async () => {
        jQuery("#dwd-wc-inject-order").on("click", async () => {
            $("#dwd-wc-inject-order").attr('disabled', 'disabled');
            inject_order();
        });
    });
})(jQuery);