<?php
add_action('woocommerce_checkout_create_order_line_item', function($item = null) {
   if (!$item instanceof WC_Order_Item_Product) {
	   return;
   }
   if (!$item->get_product() instanceof WC_Product) {
       return;
   }
   $product_data = dwd_wc_get_product_data($item->get_product());
   if ($product_data) {
       $item->add_meta_data('dwd_wc_file', $product_data['file'], true);
   }
});

add_filter('woocommerce_order_item_get_formatted_meta_data', function($meta) {
    $hidden_items = ['dwd_wc_file'];
    $new_array = [];
    foreach ($meta as $meta_item) {
        if (in_array($meta_item->key, $hidden_items)) {
            continue;
        }
        $new_array[] = $meta_item;
    }

    return $new_array;
});

add_action('woocommerce_before_order_itemmeta', function($item_id, WC_Order_Item $item, $product) {
    if (!$product instanceof WC_Product) {
		return;
	}
	$product_data = dwd_wc_get_product_data($product);
	if (!$product_data) {
		return;
	}
	?>
	<div class="form-field form-field-wide" style="display: inline-block">
		<label for="lineitem_file_<?php echo $item_id; ?>" style="display: block;">DWD File:</label>
		<input
			type="text"
			name="dwd_lineitem_file[<?php echo $item_id; ?>"
			id="lineitem_file_<?php echo $item_id; ?>"
			class=""
			style="padding: 0 2px 0 2px; width: 75%;"
			value="<?php echo $item->get_meta('dwd_wc_file', true); ?>"
		/>
		<button
                class="button dwd-wc-save-lineitem"
                type="button"
                data-lineitem="<?php echo $item_id; ?>"
                data-order="<?php echo $item->get_order_id(); ?>"
        >
            Save
        </button>
	</div>
	<?php
}, 10, 3);

add_action( 'admin_enqueue_scripts', function($hook_suffix) {
	if ( in_array( $hook_suffix, array( 'post.php', 'post-new.php' ) ) ) {
		$screen = get_current_screen();
		if ( is_object( $screen ) && $screen->post_type === "shop_order") {
			wp_enqueue_script( 'dwd-wc-admin-lineitem-file', plugins_url( 'admin/js/lineitem-file.js', DWD_WOOCOMMERCE_PLUGIN_NAME) );
		}
	}
} );


add_action('wp_ajax_dwd_wc_save_lineitem', function($data) {
    $order = wc_get_order($_POST['order']);
    $item = $order->get_item($_POST['item_id']);
    $item->add_meta_data('dwd_wc_file', $_POST['file'], true);
    $item->save();
    wp_send_json_success();
});